
import bluej.extensions.*;
import bluej.extensions.event.*;
import bluej.extensions.editor.*;

import java.net.URL;
import javax.swing.*;
import java.awt.event.*;

/**
 * Simple Wrapper bluej.extensions.editor.Editor
 *  
 * @author (Milton Jes&uacute;s Vera Contreras - miltonjesusvc@ufps.edu.co) 
 * @version 0.0000000000000001 --> Math.sin(Math.PI-Double.MIN_VALUE) --> :)
 */
public class EditorUtil
{
    private BClass curClass;
    private Editor editor;

    public EditorUtil(BClass curClass)
    throws Exception
    {
        this.curClass = curClass;
        try {
            editor = curClass.getEditor();
        } catch (Exception e) { throw new Exception("Can't create Editor for " + curClass); }
        if (editor == null)
            throw new Exception("Can't create Editor for " + curClass);
    }

    public void appendText(String appendText) {
        int line1 = editor.getLineCount();int line2 = 0;int tl = 0;
        TextLocation myBegin = new TextLocation(0, 0);
        TextLocation myEnd = new TextLocation(line1, 0);
        String newText = "*";String text = null;
        int length = editor.getTextLength();int pos = 0;
        boolean bug = false;
        
        line2 = line1;
        try
        {
            tl = editor.getLineLength(line2);
            if ((myEnd == null) || (tl <= 0)) {
                newText = "!";
                do {
                    line2--;
                    tl = editor.getLineLength(line2);
                    myEnd = new TextLocation(line2, 0);
                }
                while ((myEnd == null) || (tl == 0));
            }

            text = editor.getText(myBegin, myEnd);

            bug = checkCurlyBraces(text) != 0;

            if (!bug) {
                pos = text.lastIndexOf("}");
                text = text.substring(0, pos - 1);
            }

            newText = text + "\n    //Start GetterSetterExtension Source Code\n" + 
                         appendText + 
                         "    //End GetterSetterExtension Source Code" + 
                         (!bug ? "\n}//End class " + newText + "\n" : 
                         new StringBuilder().append("\n//").append(newText).append("\n").toString());



            editor.setText(myBegin, myEnd, newText.toString());
        }
        catch (Exception e)
        {
            throw new RuntimeException(e.getMessage() + "\n " + text + 
                "\nlength=" + length + 
                "\nc1=" + line1 + 
                "\nc2=" + line2 + 
                "\ncase=" + newText + 
                "\ne.l=" + (myEnd!=null ? myEnd.getLine(): "NULL") + 
                "\ne.c=" + (myEnd!=null ?  myEnd.getColumn() : "NULL") + 
                "\ntl=" + tl + "\n");
        }
    }

    private int checkCurlyBraces(String text)
    {
        int open = 0;int close = 0;
        for (int i = 0; i < text.length(); i++) {
            if (text.charAt(i) == '{') open++;
            if (text.charAt(i) == '}') close++;
        }
        return open - close;
    }
}